using System;

using System.Threading;

namespace MTC {

	class App
	{
		// this reference is used for the locking of the 'lock' keyword,
		// and the Monitor.Enter(ref) function
		static string str = "";

		static void Main()
		{
			
			//Thread t = new Thread(new ThreadStart(Thread1));			
			//Thread t2 = new Thread(new ThreadStart(Thread2));

			Thread t = new Thread(new ThreadStart(UpdateDB));			
			Thread t2 = new Thread(new ThreadStart(UpdateDB2));
						
			//// This is what we use to set the priority of a thread.
			//// A background file-indexer might be lowest
			//// Don't set this Property unless you know why you're doing it.
			
			//t.Priority = System.Threading.ThreadPriority.Lowest;
			//t2.Priority = System.Threading.ThreadPriority.Highest;



			// Start the threads

			t.Start();
			t2.Start();

			


			// This is just so that we can read the output before the program exits
			System.Console.ReadLine();



		}



		public static void UpdateDB() 
		{
			while(true) 
			{
				//				lock(str)
				//				{
				System.Threading.Monitor.Enter(str);			
					for (int j = 0; j < 50; j++) 
					{
						System.Console.Write("+");
					}	

					System.Console.WriteLine("");

					System.Threading.Monitor.Exit(str);	
				//}
			}
		}

		public static void UpdateDB2() 
		{
			while(true) 
			{			

//				lock(str)
//				{
					System.Threading.Monitor.Enter(str);		
					for (int j = 0; j < 50; j++) 
					{
						System.Console.Write("-");
					}	

					System.Console.WriteLine("");
				
				//}
				System.Threading.Monitor.Exit(str);	
			}
		}




		public static void Thread1() 
		{			
			for(int i = 0 ; i < 100; i++) 
			{
				System.Console.WriteLine(i*i);
		
			}
		}

		public static void Thread2() 
		{
			for(int i = 101 ; i < 200 ; i++) 
			{
				System.Console.WriteLine(i*i);
				
			}

		}



	}
}
